/*
 * TCP nice congestion control interface
 */
#ifndef __TCP_nice_H
#define __TCP_nice_H 1

/* nice variables */
struct nice {
	u32	beg_snd_nxt;	/* right edge during last RTT */
	u32	beg_snd_una;	/* left edge  during last RTT */
	u32	beg_snd_cwnd;	/* saves the size of the cwnd */
	u8	doing_nice_now;/* if true, do nice for this RTT */
	u16	cntRTT;		/* # of RTTs measured within last RTT */
	u32	minRTT;		/* min of RTTs measured within last RTT (in usec) */
	u32	baseRTT;	/* the min of all nice RTT measurements seen (in usec) */
	

	u16	nice_cntCNG;	
	u32	nice_minRTT;	
	u32	nice_maxRTT;	
	u32	nice_curRTT;	
	u8      nice_fraction;     /* 0.5 */
#define NICE_FRACTION_DEFAULT 50
	u8      nice_threshold;    /* 0.2 */
#define NICE_THRESHOLD_DEFAULT 20

};

extern void tcp_nice_init(struct sock *sk);
extern void tcp_nice_state(struct sock *sk, u8 ca_state);
extern void tcp_nice_pkts_acked(struct sock *sk, u32 cnt, ktime_t last);
extern void tcp_nice_cwnd_event(struct sock *sk, enum tcp_ca_event event);
extern void tcp_nice_get_info(struct sock *sk, u32 ext, struct sk_buff *skb);

#endif	/* __TCP_nice_H */
